VERSION 5.00
Begin VB.Form frmPlotter 
   Caption         =   "frmStandard"
   ClientHeight    =   5970
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7740
   Icon            =   "Plotter.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5970
   ScaleWidth      =   7740
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Frame fraButtons 
      BorderStyle     =   0  'Kein
      Height          =   400
      Left            =   360
      TabIndex        =   1
      Top             =   5400
      Width           =   7000
      Begin VB.CommandButton cmdAction 
         Caption         =   "START"
         Height          =   375
         Left            =   5640
         TabIndex        =   5
         Top             =   0
         Width           =   1335
      End
      Begin VB.CommandButton cmdEnde 
         Caption         =   "ENDE"
         Height          =   375
         Left            =   4200
         TabIndex        =   4
         Top             =   0
         Width           =   1335
      End
      Begin VB.ComboBox cboProgramme 
         Height          =   315
         Left            =   0
         Style           =   2  'Dropdown-Liste
         TabIndex        =   3
         Top             =   0
         Width           =   1575
      End
      Begin VB.ComboBox cboPort 
         Height          =   315
         Left            =   1680
         Style           =   2  'Dropdown-Liste
         TabIndex        =   2
         Top             =   0
         Width           =   1575
      End
   End
   Begin VB.PictureBox picBlatt 
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      Height          =   4965
      Left            =   360
      ScaleHeight     =   4905
      ScaleWidth      =   6945
      TabIndex        =   0
      Top             =   240
      Width           =   7000
   End
End
Attribute VB_Name = "frmPlotter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ------------------------------------------------------------------------------
'
' frmPlotter(Plotter.frm)                                 Ulrich Mller 10.02.99
'                                                         Procida 400NT    VB6.0
' Adaption der originalen DOS Software fr den Plotter/Scanner 30571
'
' Funktionen (entsprechen denen im Hanbuch 39460 beschriebenen) :
' ftHome()
' ftOrigin()
' ftSetOrigin(X, Y)
' ftScale(XMin, XMax, YMin, YMax)
' ftAxis(XA, YA, XE, YE, X1, Y1, X2, Y2, SK, XText, YText)
' ftBox(XA, XE, YA, YE, S)
' ftCircle(X, Y, RX, Ry, WA, WE)
' ftLine(X, Y)
' ftRLine(X, Y)
' ftMove(X, Y)
' ftRMove(X, Y)
' ftChar(X, Y, A, R, G)
' ftRChar(X, Y, A, R, G)
'
' ber ComboBox whlbare Anwendungen : FunktionsPlot, TEST, erweiterbar
'
' ------------------------------------------------------------------------------

Option Explicit

Private Const cMotorsLLL = &H15&
Private Const cMotorsLLR = &H25&
Private Const cMotorsLRL = &H19&
Private Const cMotorsLRR = &H29&
Private Const cMotorsRLL = &H16&
Private Const cMotorsRLR = &H26&
Private Const cMotorsRRL = &H1A&
Private Const cMotorsRRR = &H2A&
Private Const cMaskeStift = &H40&
Private Const cStift = 4
Private Const cMaskeEndeX = &H40&, cMaskeEndeY = &H80&, cMaskeEndeXY = &HC0&

Private XM&, YM&        ' --- Breite, Hhe der Plotterflche in Plotterschritten
Private XJ&, YJ&        ' --- Absolute Koordinaten des akt. Punktes
                        '     (0,0)   : linke, untere Ecke
                        '     Einheit : ein Plotterschritt
Private XH!, YH!        ' --- Virtueller (logischer) Nullpunkt
                        '     in absoluten Koordinaten
Private XS!, YS!        ' --- Skalierung : Anzahl Plotterschritte/log Einheit
Private Xout As Boolean, Yout As Boolean ' --- True wenn XJ/YJ auerhalb
                        '     der Plotterflche 0 ... XM, 0 ... YM
Private MG As Boolean   ' --- Status Stift
Private cStiftAb&       '     Stiftfarbe
Private ScreenOnly As Boolean ' --- Ausgabe nur auf Screen

Private ZTab%(0 To 255, 0 To 9)  ' --- Zeichentabelle
Private ZRichtung&, ZGrsse&     ' --- Zeichen Richtung und Gre

Private Ziehen As Boolean, WFest&, HFest&, WMin&, HMin&, WAkt&, HAkt&
Private Sub Beenden()

  If Not ScreenOnly Then
    ClearMotors ft
    CloseInterface ft
  End If
  End
  
End Sub


Private Sub BereichsLimit()

' --- Feststellen ob im Plotbereich (61000) ---

  If Xout Or Yout Then   ' --- Letzte Position auerhalb
    Xout = XJ < 0 Or XJ > XM
    Yout = YJ < 0 Or YJ > YM
    If Xout Or Yout Then
      Exit Sub
    Else
      If MG Then
        MG = True
        StiftAb
      End If
    End If
  Else                   ' --- Letzte Position innerhalb
    Xout = XJ < 0 Or XJ > XM
    Yout = YJ < 0 Or YJ > YM
    If Xout Or Yout Then
      MG = True
      StiftAuf
    End If
  End If
  
End Sub

Private Sub EndTaster()

' --- Abfrage Endtaster im laufenden Betrieb (60000) ---

' --- E7 oder E8 : Nachricht "Dejustierung"

  If ((ft.InputStatus And cMaskeEndeX) <> 0 And XJ <> 0) Or _
    ((ft.InputStatus And cMaskeEndeY) <> 0 And YJ <> 0) Then
    MsgBox "Achtung Dejustierung!", vbExclamation + vbOKOnly, "ftPlot"
    Beenden
  End If
  
End Sub

Private Sub ftAxis(ByVal XA!, ByVal YA!, ByVal XE!, ByVal YE!, ByVal X1!, ByVal Y1!, ByVal X2!, ByVal Y2!, ByVal SK&, ByVal XText$, ByVal YText$)

' --- Zeichnen und Beschriften eines Koordinatensystems,
'     setzen globaler Werte            (22000) -----------------------
'     XA, YA, XE, YE : Lage der Achsen in der bisherigen Skalierung
'     X1, X2, Y1, Y2 : Koordinatenwerte an den Achsenendpunkten
'     Skalierung der Plotterflche entspr. Koordinatenachsen
'     X0, X3, Y0, Y3 : neue Koordinaten am Rande der Plotterflche
'     SK <> 0 : Beschriftung des Koordinatensystems

Dim I&, X0!, X3!, XD!, Y0!, Y3!, YD!, A$

' --- neue Skalierung ------------

  X0 = X1 - (X2 - X1) * (XA + XH / XS) / (XE - XA)
  X3 = X2 + (X2 - X1) * ((XM - XH) / XS - XE) / (XE - XA)
  Y0 = Y1 - (Y2 - Y1) * (YA + YH / YS) / (YE - YA)
  Y3 = Y2 + (Y2 - Y1) * ((YM - YH) / YS - YE) / (YE - YA)
  XS = XM / (X3 - X0)
  YS = YM / (Y3 - Y0)
  XH = -X0 * XS
  YH = -Y0 * YS
  
' --- X-Achse zeichen -----

  If Y1 <= 0 And Y2 >= 0 Then
    ftMove X1, 0
    ftLine X2, 0
    ftRLine -10 / XS, 5 / YS
    ftRMove 10 / XS, -5 / YS
    ftRLine -10 / XS, -5 / YS
    If SK <> 0 Then              ' --- Beschriftung
      XE = Int(Log(X2 - X1) / Log(10) - 0.3) ' --- Schrittweite fr Skalierung
      XD = 1
      If XE > 0 Then
        For I = 1 To XE
          XD = XD * 10
        Next I
      ElseIf XE < 0 Then
        For I = XE To -1
          XD = XD / 10
        Next I
      End If
      If (Len(Str$(XD)) + 1) * 10 > XD * XS Then
        XD = XD * 5
      ElseIf (Len(Str$(XD)) + 1) * 40 < XD * XS Then
        XD = XD / 2
      End If
      X0 = 0
      Do While X0 + 1.2 * XD < X2
        X0 = X0 + XD
      Loop
      X0 = X0 + XD
      Do
        X0 = X0 - XD
        If Abs(X0) >= XD / 2 Then
          ftMove X0, 3 / YS
          ftLine X0, -3 / YS
          A = Str$(IIf(Abs(X0) < 1, Round(X0, 1), X0))
          If X0 > 0 Then A$ = "+" & Right$(A, Len(A) - 1)
          ftChar X0 - 5 * Len(A) / XS, -18 / YS, A, 0, 2
        End If
      Loop While X0 - 1.2 * XD > X1
      ftChar X2 - 10 * Len(XText) / XS, 12 / YS, XText, 0, 2
    End If
  End If
  
  If X1 > 0 Or X2 < 0 Then Exit Sub
  
' --- Y-Achse zeichen -----
  ftMove 0, Y1
  ftLine 0, Y2
  ftRLine -5 / XS, -10 / YS
  ftRMove 5 / XS, 10 / YS
  ftRLine 5 / XS, -10 / YS
  If SK = 0 Then Exit Sub                ' --- Beschriftung
  YE = Int(Log(Y2 - Y1) / Log(10) - 0.3) '     Schrittweite fr Skalierung
  YD = 1
  If YE > 0 Then
    For I = 1 To YE
      YD = YD * 10
    Next I
  ElseIf YE < 0 Then
    For I = YE To -1
      YD = YD / 10
    Next I
  End If
  If YD * YS < 20 Then
    YD = YD * 100
  ElseIf YD * YS > 60 Then
    YD = YD / 2
  End If
  Y0 = 0
  Do While Y0 + 1.2 * YD < Y2
    Y0 = Y0 + YD
  Loop
  Y0 = Y0 + YD
  Do
    Y0 = Y0 - YD
    If Abs(Y0) >= YD / 2 Then
    ftMove -3 / XS, Y0
    ftLine 3 / XS, Y0
    A = Str$(IIf(Abs(Y0) < 1, Round(Y0, 1), Y0))
    If Y0 > 0 Then A = "+" & Right$(A, Len(A) - 1)
    ftChar 8 / XS, Y0 - 6 / YS, A, 0, 2
    End If
  Loop While Y0 - 1.2 * YD > Y1
  ftChar -12 / XS, Y2 - 10 * Len(A) / YS, YText, 0, 2
    
End Sub


Private Sub ftBox(ByVal XA!, ByVal XE!, ByVal YA!, ByVal YE!, Optional S& = 0)

' --- Zeichnen eines Rechtecks, optional mit Schraffur (20000) ---
'     XA, XE, YA, YE : Eckkoordinaten
'     S : Schraffurabstand und Neigung (negativ : nach links), 0 = keine

Dim X!, Y!, XD!

  If XA > XE Then
    X = XE
    XE = XA
    XA = X
  End If
  If YA > YE Then
    Y = YE
    YE = YA
    YA = Y
  End If
    
' --- Rechteck zeichnen -----------

  ftMove XA, YA
  ftLine XA, YE
  ftLine XE, YE
  ftLine XE, YA
  ftLine XA, YA
  
  If S = 0 Then Exit Sub
  
' ---- Schraffur ----

  For XD = 0 To (XE - XA) + (YE - YA) Step Abs(S)
    If XD < (YE - YA) Then
      X = XA
      Y = YE - XD
    Else
      X = XA + XD + YA - YE
      Y = YA
    End If
    If S < 0 Then Y = YE + YA - Y
    ftMove X, Y
    If XD > (XE - XA) Then
      X = XE
      Y = YE + XE - XA - XD
    Else
      X = XA + XD
      Y = YE
    End If
    If S < 0 Then Y = YE + YA - Y
    ftLine X, Y
  Next XD
  
End Sub


Private Sub ftChar(ByVal X!, ByVal Y!, ByVal A$, Optional R, Optional G)

' --- Plotten A$ ab x, y in Richtung R
'     R= 0 : waagerecht, 1 : senkrecht,
'     2 : waagerecht auf dem Kopf, 3 : senkrecht gespiegelt
'     und relative Gre G ( Default = 2)

  ftMove X, Y
  ZeichenFolge A, IIf(IsMissing(R), ZRichtung, R), IIf(IsMissing(G), ZGrsse, G)
  
End Sub

Private Sub ftCircle(ByVal X!, ByVal Y!, ByVal RX!, ByVal RY!, ByVal WA!, ByVal WE!)

' --- Zeichnen von (Teil) Kreisen und Ellipsen ( 21000) ----
'     X, Y   : Mittelpunktskoordinaten
'     RX, RY : Radius X, Y
'     WA, WE : Anfangs-, Endwinkel

Dim XA!, YA!, WS!, W!

  RX = Abs(RX)
  RY = Abs(RY)
  XA = X
  YA = Y
  X = XA + RX * Cos(Atn(1) * WA / 45)
  Y = YA + RY * Sin(Atn(1) * WA / 45)
  ftMove X, Y
  
  WS = Sgn(WE - WA) * 800 / (RX * XS + RY * YS + 40)
  For W = WA To WE Step WS
    X = XA + RX * Cos(Atn(1) * W / 45)
    Y = YA + RY * Sin(Atn(1) * W / 45)
    ftLine X, Y
  Next W
  
  X = XA + RX * Cos(Atn(1) * WE / 45)
  Y = YA + RY * Sin(Atn(1) * WE / 45)
  ftLine X, Y
  
End Sub


Private Sub ftHome()
  
' --- Init Blatt, Fahren zur Home-Position (40000) ---
'     Skalierung picBlatt : in Plotterschritten a 0,39 mm
'     Steigung 4,75 mm / 48 Schritte/U * 4er Zyklus

' --- Init Werte ---
  
  StiftAuf
  XM = 680
  YM = 500
  XH = 0#
  YH = 0#
  XS = 1#
  YS = 1#
  
' --- Fahren auf Home bzw. Clear picBlatt ---
  picBlatt.Cls
  picBlatt.Scale (0, YM)-(XM, 0)
  picBlatt.CurrentX = 300
  picBlatt.CurrentY = 250
  
  If Not ScreenOnly Then picBlatt.Print "Fhrt auf Home-Position"
  
  Xout = False
  Yout = False
  ZRichtung = 0#
  ZGrsse = 2#
  
  DoEvents
  If ScreenOnly Then Exit Sub
  ft.InputStatus = 0
  ft.MotorStatus = 0
    
' --- Beide Motoren gegen Endtaster
  Do While (ft.InputStatus And cMaskeEndeXY) = 0
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRLL
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLLL
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
    SetMotors ft
    DoEvents
  Loop
' --- Motor X gegen Endtaster
  Do While (ft.InputStatus And cMaskeEndeX) = 0
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRLR
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLLR
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
    SetMotors ft
    DoEvents
  Loop
' --- Motor X frei von Endtaster
  Do While (ft.InputStatus And cMaskeEndeX) <> 0
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLLR
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRLR
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
    SetMotors ft
    DoEvents
  Loop
' --- Motor Y gegen Endtaster
  Do While (ft.InputStatus And cMaskeEndeY) = 0
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRL
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRL
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
    SetMotors ft
    DoEvents
  Loop
' --- Motor y frei von Endtaster
  Do While (ft.InputStatus And cMaskeEndeY) <> 0
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRL
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRL
    SetMotors ft
    ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
    SetMotors ft
    DoEvents
  Loop
  XpYpDiagonale                ' --- Motoren 2 Schritt Abstand von Ende
  XpYpDiagonale
  XJ = 0
  YJ = 0
  picBlatt.Cls
  
End Sub

Private Sub ftLine(ByVal X!, ByVal Y!)

' --- Linie von aktueller Position nach x, y (44000) ---

  StiftAb
  Strich Int(XH + XS * X - XJ + 0.5), Int(YH + YS * Y - YJ + 0.5)
  
End Sub


Private Sub ftMove(ByVal X!, ByVal Y!)

' --- Zur Position x,y fahren (45000) -------

  StiftAuf
  Strich Int(XH + XS * X - XJ + 0.5), Int(YH + YS * Y - YJ + 0.5)

End Sub

Private Sub ftOrigin()

' --- Fahren zum Nullpunkt ---

  ftMove 0, 0

End Sub


Private Sub ftRChar(ByVal X!, ByVal Y!, ByVal A$, Optional R, Optional G)

' --- Plotten A$ um x, y von der alten Position versetzt, R: Richtung
'     R= 0 : waagerecht, 1 : senkrecht,
'     2 : waagerecht auf dem Kopf, 3 : senkrecht gespiegelt
'     und relative Gre G ( Default = 2)

  ftRMove X, Y
  ZeichenFolge A, IIf(IsMissing(R), ZRichtung, R), IIf(IsMissing(G), ZGrsse, G)
  
End Sub

Private Sub ftRLine(ByVal X!, ByVal Y!)

' --- x, y Werte Zeichnen (46000) ----

  StiftAb
  Strich Int(XS * X + 0.5), Int(YS * Y + 0.5)
  
End Sub

Private Sub ftRMove(ByVal X!, ByVal Y!)

' ---- x, y Werte Fahren (47000) ----

  StiftAuf
  Strich Int(XS * X + 0.5), Int(YS * Y + 0.5)

End Sub

Private Sub ftScale(ByVal XMin!, ByVal XMax!, ByVal YMin!, ByVal YMax!)

' --- Setzen Skalierung ----

  If Not (XMin < XMax) Or Not (YMin < YMax) Then Exit Sub
  XS = XM / (XMax - XMin)
  XS = YM / (YMax - YMin)
  XH = -XMin * XS
  YH = -YMin * YS
  
End Sub


Private Sub ftSetOrigin(ByVal X&, ByVal Y&)

' --- Setzen Koordinaten Nullpunkt ---

  XH = XH + X * XS
  YH = YH + Y * YS
  
End Sub

Private Sub FunktionPlot()

Dim FunMin!, FunMax!, FunText$, XA!, XE!, X!
Dim X0!, X1!, X2!, Y1!, Y2!, YA!, YE!, Y!

  FunText = "Sin(x)*Exp(-x/10)"
  XA = 0
  XE = 62.8
  
  FunMin = FunSinExp(XA)
  FunMax = FunSinExp(XA)
  
  For X = XA To XE Step (XE - XA) / 200
    If FunSinExp(X) > FunMax Then FunMax = FunSinExp(X)
    If FunSinExp(X) < FunMin Then FunMin = FunSinExp(X)
  Next X
  
  X1 = XA - (XE - XA) / 20
  X2 = XE + (XE - XA) / 20
  Y1 = FunMin - (FunMax - FunMin) / 20
  Y2 = FunMax + (FunMax - FunMin) / 20
  XA = 10
  XE = XM - 10
  YA = 10
  YE = YM - 10
  
  ftAxis XA, YA, XE, YE, X1, Y1, X2, Y2, 1, "X", FunText
  
  ftMove X1 + (X2 - X1) / 22, FunSinExp(X)
  
  For X0 = X1 + (X2 - X1) / 22 To X2 - (X2 - X1) / 22 Step (X2 - X1) / 220
    ftLine X0, FunSinExp(X0)
  Next X0
  
End Sub


Private Function FunSinExp(X!)

  FunSinExp = Sin(X) * Exp(-X / 10)

End Function


Private Sub StiftAb()
' --- Senken Stift (58000) ----
  
  If MG Then Exit Sub
  If Xout Or Yout Then Exit Sub
  ' --- Code Senken
  ClearMotors ft
  Sleep 10
  SetMotor ft, cStift, ftiEin
  Sleep 10
  MG = True
  
End Sub

Private Sub StiftAuf()

' --- Heben Stift (59000) ---

  If Not MG Then Exit Sub
  ' --- Code Heben
  SetMotor ft, cStift, ftiEin
  SetMotor ft, cStift, ftiAus
  Sleep 10
  MG = False
  
End Sub

Private Sub Strich(XR&, YR&)

' --- Allgemeiner Fahrauftrag ---

Dim DX&, DY&, D&, NX&, NY&

  DX = Abs(XR)                      ' --- Anzahl Plotterschritte
  DY = Abs(YR)
  NX = 0                            ' --- Schrittzhler
  NY = 0
  D = 0                             ' --- Abstand zur optimalen Geraden
  Do Until NX = DX And NY = DY
    If Abs(D + DY) < Abs(D + DY - DX) Then  ' --- X-Schritt
      If XR > 0 Then XPlusSchritt Else XMinusSchritt
      NX = NX + 1
      D = D + DY
    ElseIf Abs(D - DX) < Abs(D + DY - DX) Then ' --- Y-Schritt
      If YR > 0 Then YPlusschritt Else YMinusSchritt
      NY = NY + 1
      D = D - DX
    Else                            ' --- Diagonale
      If XR > 0 Then
        If YR > 0 Then XpYpDiagonale Else XpYmDiagonale
      Else
        If YR > 0 Then XmYpDiagonale Else XmYmDiagonale
      End If
      NX = NX + 1
      NY = NY + 1
      D = D + DY - DX
    End If
  Loop
  
End Sub


Private Sub TestPlot()

Dim I&

'  ftOrigin
'  ftChar 10, 50, "ABCDEFGHIJKLMNOPQRSTUVWXYZ", 0, 4
'  ftChar 10, 20, "abcdefghijklmnopqrstuvwxyz", 0, 4
'  ftChar 100, 100, "Hoch", 1, 4
  ftBox 100, 200, 100, 200, -60
'  ftCircle 300, 250, 100, 100, 0, 360
  
'  ftAxis 20, 20, 660, 480, -50, -50, 50, 100, 1, "XAchse", "YAchse"
  
End Sub


Private Sub XMinusSchritt()

' --- -X Bewegung (51000) ----

  XJ = XJ - 1
  BereichsLimit
  If Xout Then Exit Sub
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then picBlatt.Line (XJ + 1, YJ)-(XJ, YJ), cStiftAb
  DoEvents
  If ScreenOnly Then Exit Sub
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRLR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLLR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
  SetMotors ft
  EndTaster
    
End Sub

Private Sub XPlusSchritt()

' --- +X Bewegung (50000) ----

  XJ = XJ + 1
  BereichsLimit
  If Xout Then Exit Sub
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then picBlatt.Line (XJ - 1, YJ)-(XJ, YJ), cStiftAb
  DoEvents
  If ScreenOnly Then Exit Sub
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLLR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRLR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
  SetMotors ft
  EndTaster
  
End Sub

Private Sub XpYpDiagonale()

' --- +X/+Y-Diagonale (54000) --------

  XJ = XJ + 1
  YJ = YJ + 1
  BereichsLimit
  If Xout Then
    YPlusschritt
    Exit Sub
  ElseIf Yout Then
    XPlusSchritt
    Exit Sub
  End If
  
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then picBlatt.Line (XJ - 1, YJ - 1)-(XJ, YJ), cStiftAb
  DoEvents
  If ScreenOnly Then Exit Sub
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLLL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRLL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
  SetMotors ft
  EndTaster

End Sub

Private Sub XpYmDiagonale()

' --- +X/-Y-Diagonale (55000) --------

  XJ = XJ + 1
  YJ = YJ - 1
  BereichsLimit
  If Xout Then
    YMinusSchritt
    Exit Sub
  ElseIf Yout Then
    XPlusSchritt
    Exit Sub
  End If
  
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then picBlatt.Line (XJ - 1, YJ + 1)-(XJ, YJ), cStiftAb
  DoEvents
  If ScreenOnly Then Exit Sub
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLLR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRLR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
  SetMotors ft
  EndTaster

End Sub

Private Sub XmYmDiagonale()

' --- -X/-Y-Diagonale (57000) --------

  XJ = XJ - 1
  YJ = YJ - 1
  BereichsLimit
  If Xout Then
    YMinusSchritt
    Exit Sub
  ElseIf Yout Then
    XMinusSchritt
    Exit Sub
  End If
  
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then picBlatt.Line (XJ + 1, YJ + 1)-(XJ, YJ), cStiftAb
  DoEvents
  If ScreenOnly Then Exit Sub
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRLL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLLL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
  SetMotors ft
  EndTaster

End Sub

Private Sub XmYpDiagonale()

' --- -X/+Y-Diagonale (56000) --------

  XJ = XJ - 1
  YJ = YJ + 1
  BereichsLimit
  If Xout Then
    YPlusschritt
    Exit Sub
  ElseIf Yout Then
    XMinusSchritt
    Exit Sub
  End If
  
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then picBlatt.Line (XJ + 1, YJ - 1)-(XJ, YJ), cStiftAb
  DoEvents
  If ScreenOnly Then Exit Sub
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRLR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLLR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
  SetMotors ft
  EndTaster

End Sub
Private Sub YMinusSchritt()

' --- -Y Bewegung (53000) ----

  YJ = YJ - 1
  BereichsLimit
  If Yout Then Exit Sub
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then picBlatt.Line (XJ, YJ + 1)-(XJ, YJ), cStiftAb
  DoEvents
  If ScreenOnly Then Exit Sub
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
  SetMotors ft
  EndTaster

End Sub

Private Sub YPlusschritt()

' --- +Y Bewegung (52000) ----

  YJ = YJ + 1
  BereichsLimit
  If Yout Then Exit Sub
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then picBlatt.Line (XJ, YJ - 1)-(XJ, YJ), cStiftAb
  DoEvents
  If ScreenOnly Then Exit Sub
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRR
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsLRL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRL
  SetMotors ft
  EndTaster
  ft.MotorStatus = (ft.MotorStatus And cMaskeStift) + cMotorsRRR
  SetMotors ft
  EndTaster

End Sub


Private Sub ZeichenFolge(A$, R&, G&)

' --- Zeichnen A$ ab aktueller Position in ZRichtung, ZGrsse ---
'     in ZTab sind jeweils zwei Koordinatenpaare kodiert

Dim I&, J&, J1&, Xalt&, Yalt&, Xneu&, Yneu&, Pens As Boolean, Zeichen&

  If Len(A) = 0 Then Exit Sub
  For I = 1 To Len(A)                    ' --- Schleife ber Zeichen
    Xalt = 0                             '     Startpunkt
    Yalt = 3
    If Mid$(A, I, 1) = vbBack Then       ' --- Zeichen berschreiben
      ZeichenVektor Xalt, -5, Yalt, 3, False, R, G
    Else                                 ' --- Zeichen auf neue Position
      For J = 0 To 8                     ' --- Schleife ber ZeichenVektor
        Zeichen = ZTab(Asc(Mid$(A, I, 1)), J)
        If Zeichen = 0 Then Exit For
        For J1 = 0 To 1                  ' --- Code Teil 1 / 2
          If Zeichen > 0 Then
            Xneu = Int(Zeichen / 1000)
            Yneu = Int(Zeichen / 100) - 10 * Xneu
            Zeichen = 100 * (Zeichen - 1000 * Xneu - 100 * Yneu)
            Pens = False
            If Xneu > 4 Then
              Xneu = Xneu - 5
              Pens = True
            End If
            ZeichenVektor Xalt, Xneu, Yalt, Yneu, Pens, R, G
            Xalt = Xneu
            Yalt = Yneu
          End If
        Next J1
      Next J
      ZeichenVektor Xalt, 5, Yalt, 3, False, R, G
    End If
  Next I
  
End Sub

Private Sub ZeichenVektor(Xalt&, Xneu&, Yalt&, Yneu&, Pens As Boolean, R, G)

' --- Zeichnen Vektor relativ zur aktuellen Position ---

Dim X&, Y&, XY&

  X = (Xneu - Xalt) * G
  Y = (Yneu - Yalt) * G
  Select Case R
  Case 0
  Case 1
    XY = X
    X = -Y
    Y = XY
  Case 2
    X = -X
    Y = -Y
  Case 3
    XY = X
    X = Y
    Y = -XY
  End Select
  If Pens Then ftRLine X / XS, Y / YS Else ftRMove X / XS, Y / YS
  
End Sub


Private Sub cmdAction_Click()

' --- Aktivieren Plotter, Zeichnen einer Seite ---

Dim res&

  ScreenOnly = True
  Ziehen = False
  If cboPort.ListIndex > 0 Then
    res = OpenInterface(ft, cboPort.Text)
    If res = ftiFehler Then
      MsgBox "Interface Problem : " & cboPort, vbExclamation + vbOKOnly, "ftPlot"
      Exit Sub
    End If
    ScreenOnly = False
  End If
  
  cmdEnde.Caption = "Abbrechen"
  ftHome
  Select Case cboProgramme.Text
  Case "TEST"
    TestPlot
  Case "SinExp"
    FunktionPlot
  Case Else
  End Select
  
  If Not ScreenOnly Then CloseInterface ft
  cmdEnde.Caption = "ENDE"
  ScreenOnly = False
  Ziehen = True
  cmdEnde.SetFocus
  
End Sub


Private Sub cmdEnde_Click()

  Beenden
  
End Sub


Private Sub Form_Load()

Dim I&, J&, W&

' --- Projekt | Eigenschaften | Erstellen | ProductName
  Me.Caption = App.ProductName
  
  Ziehen = True
  WMin = Me.Width
  WAkt = WMin
  WFest = Me.ScaleWidth - picBlatt.Width
  HMin = Me.Height
  HAkt = HMin
  HFest = Me.ScaleHeight - picBlatt.Height
  
  cStiftAb = picBlatt.ForeColor
  
  cboProgramme.Clear
  cboProgramme.AddItem "PlotProgramme"
  cboProgramme.AddItem "TEST"
  cboProgramme.AddItem "SinExp"
  cboProgramme.ListIndex = 2
  
  cboPort.Clear
  cboPort.AddItem "SCR"
  cboPort.AddItem "COM1"
  cboPort.AddItem "COM2"
  cboPort.AddItem "COM3"
  cboPort.AddItem "COM4"
  cboPort.AddItem "LPT1"
  cboPort.AddItem "LPT2"
  cboPort.AddItem "LPT3"
  cboPort.ListIndex = 0
  ScreenOnly = IIf(cboPort.Text = "SCR", True, False)
  
  ChDir App.Path
  ChDrive App.Path
  Open "IBMChar.DAT" For Input As #1
  For I = 0 To 255
    Input #1, W
    For J = 0 To 9
      Input #1, ZTab(I, J)
    Next J
  Next I
  Close #1
  
End Sub


Private Sub Form_Resize()

Dim WDelta&, HDelta&

  If Me.WindowState = 1 Then Exit Sub
  If Not Ziehen Then
    Me.Width = WAkt
    Me.Height = HAkt
    Exit Sub
  End If
  If Me.Width < WMin Then Me.Width = WMin
  If Me.Height < HMin Then Me.Height = HMin
  WDelta = Me.ScaleWidth - picBlatt.Width - WFest
  HDelta = Me.ScaleHeight - picBlatt.Height - HFest
  
  picBlatt.Width = picBlatt.Width + WDelta
  picBlatt.Height = picBlatt.Height + HDelta
  
  fraButtons.Top = fraButtons.Top + HDelta
  fraButtons.Width = fraButtons.Width + WDelta
  cmdAction.Left = cmdAction.Left + WDelta
  cmdEnde.Left = cmdEnde.Left + WDelta
  
  WAkt = Me.Width
  HAkt = Me.Height
  picBlatt.Cls
  cmdAction.SetFocus
  
End Sub


Private Sub Form_Unload(Cancel As Integer)

  Beenden
  
End Sub


