VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPlot85"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ------------------------------------------------------------------------------
'
' clsPlot85(ftPlot85.cls)                                 Ulrich Mller 26.02.99
'                                                         Procida 400NT    VB6.0
' Funktionen zum Betrieb des Plotter/Scanners 30571
' erforderlich FishF632.DLL oder FishFRT6.DLL
' Zifferangaben (in Klammern) im Procedurkopf beziehen sich auf die
' Zeilennummer der Original DOS GWBasic-Source
'
' ------------------------------------------------------------------------------

Option Explicit

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMsec&)

Private ft As clsFishFace

Private Const cMotorsLLL = &H15&, cMotorsLLR = &H25&, cMotorsLRL = &H19&
Private Const cMotorsLRR = &H29&, cMotorsRLL = &H16&, cMotorsRLR = &H26&
Private Const cMotorsRRL = &H1A&, cMotorsRRR = &H2A&
Private Const cMaskeStift = &H40&, cStift = 4
Private Const cMaskeEndeX = &H40&, cMaskeEndeY = &H80&, cMaskeEndeXY = &HC0&

Public Enum psKonstanten
  psHor = 0
  psVer = 1
  psInvHor = 2
  psInvVer = 3
  psText = -1
  psNoText = 0
End Enum

Private XMax&, YMax&    ' --- Breite, Hhe der Plotterflche in Plotterschritten
Private XposI&, YposI&  ' --- Absolute Koordinaten des akt. Punktes
                        '     (0,0)   : linke, untere Ecke
                        '     Einheit : ein Plotterschritt
Private XHome!, YHome!  ' --- Virtueller (logischer) Nullpunkt
                        '     in absoluten Koordinaten
Private XScale!, YScale! ' --- Skalierung : Anzahl Plotterschritte/log Einheit
Private Xout As Boolean, Yout As Boolean ' --- True wenn XposI/YposI auerhalb
                        '     der Plotterflche 0 ... XMax, 0 ... YMax
Private MG As Boolean   ' --- Status Stift
Private cStiftAb&       '     Stiftfarbe
Private PlotScreen As Boolean    ' --- Ausgabe in Picturebox
Private SP As PictureBox         '     Adresse der Picturebox
Private PlotPlotter As Boolean   '     Ausgabe auf Plotter
Private ftOutputDelay&           '     Wert Zeitschleife bei LPT-Betrieb

Private ZTab%(0 To 255, 0 To 9)  ' --- Zeichentabelle

Public Sub psAxis(ByVal XA!, ByVal YA!, ByVal XE!, ByVal YE!, _
  ByVal X1!, ByVal Y1!, ByVal X2!, ByVal Y2!, _
  Optional ByVal ScaleText As Boolean = True, _
  Optional ByVal XText$ = "", Optional ByVal YText$ = "")

' --- Zeichnen und Beschriften eines Koordinatensystems,
'     setzen globaler Werte            (22000) -----------------------
'     XA, YA, XE, YE : Lage der Achsen in der bisherigen Skalierung
'     X1, X2, Y1, Y2 : Koordinatenwerte an den Achsenendpunkten
'     Skalierung der Plotterflche entspr. Koordinatenachsen
'     X0, X3, Y0, Y3 : neue Koordinaten am Rande der Plotterflche
'     SK <> 0 : Beschriftung des Koordinatensystems

Dim i&, X0!, X3!, XD!, Y0!, Y3!, YD!, A$
On Error Resume Next

' --- neue Skalierung ------------

  X0 = X1 - (X2 - X1) * (XA + XHome / XScale) / (XE - XA)
  X3 = X2 + (X2 - X1) * ((XMax - XHome) / XScale - XE) / (XE - XA)
  Y0 = Y1 - (Y2 - Y1) * (YA + YHome / YScale) / (YE - YA)
  Y3 = Y2 + (Y2 - Y1) * ((YMax - YHome) / YScale - YE) / (YE - YA)
  XScale = XMax / (X3 - X0)
  YScale = YMax / (Y3 - Y0)
  XHome = -X0 * XScale
  YHome = -Y0 * YScale
  
' --- X-Achse zeichen -----

  If Y1 <= 0 And Y2 >= 0 Then
    psMove X1, 0
    psLine X2, 0
    psRLine -10 / XScale, 5 / YScale
    psRMove 10 / XScale, -5 / YScale
    psRLine -10 / XScale, -5 / YScale
    If ScaleText Then                        ' --- Beschriftung
      XE = Int(Log(X2 - X1) / Log(10) - 0.3) ' --- Schrittweite fr Skalierung
      XD = 1
      If XE > 0 Then
        For i = 1 To XE
          XD = XD * 10
        Next i
      ElseIf XE < 0 Then
        For i = XE To -1
          XD = XD / 10
        Next i
      End If
      If (Len(Str$(XD)) + 1) * 10 > XD * XScale Then
        XD = XD * 5
      ElseIf (Len(Str$(XD)) + 1) * 40 < XD * XScale Then
        XD = XD / 2
      End If
      X0 = 0
      Do While X0 + 1.2 * XD < X2
        X0 = X0 + XD
      Loop
      X0 = X0 + XD
      Do
        X0 = X0 - XD
        If Abs(X0) >= XD / 2 Then
          psMove X0, 3 / YScale
          psLine X0, -3 / YScale
          A = Str$(IIf(Abs(X0) < 1, Round(X0, 1), X0))
          If X0 > 0 Then A$ = "+" & Right$(A, Len(A) - 1)
          psChar X0 - 5 * Len(A) / XScale, -18 / YScale, A, 0, 2
        End If
      Loop While X0 - 1.2 * XD > X1
      If Len(XText) > 0 Then psChar X2 - 10 * Len(XText) / XScale, 12 / YScale, XText, 0, 2
    End If
  End If
  
  If X1 > 0 Or X2 < 0 Then Exit Sub
  
' --- Y-Achse zeichen -----
  psMove 0, Y1
  psLine 0, Y2
  psRLine -5 / XScale, -10 / YScale
  psRMove 5 / XScale, 10 / YScale
  psRLine 5 / XScale, -10 / YScale
  If Not ScaleText Then Exit Sub                ' --- Beschriftung
  YE = Int(Log(Y2 - Y1) / Log(10) - 0.3) '     Schrittweite fr Skalierung
  YD = 1
  If YE > 0 Then
    For i = 1 To YE
      YD = YD * 10
    Next i
  ElseIf YE < 0 Then
    For i = YE To -1
      YD = YD / 10
    Next i
  End If
  If YD * YScale < 20 Then
    YD = YD * 100
  ElseIf YD * YScale > 60 Then
    YD = YD / 2
  End If
  Y0 = 0
  Do While Y0 + 1.2 * YD < Y2
    Y0 = Y0 + YD
  Loop
  Y0 = Y0 + YD
  Do
    Y0 = Y0 - YD
    If Abs(Y0) >= YD / 2 Then
    psMove -3 / XScale, Y0
    psLine 3 / XScale, Y0
    A = Str$(IIf(Abs(Y0) < 1, Round(Y0, 1), Y0))
    If Y0 > 0 Then A = "+" & Right$(A, Len(A) - 1)
    psChar 8 / XScale, Y0 - 6 / YScale, A, 0, 2
    End If
  Loop While Y0 - 1.2 * YD > Y1
  If Len(YText) > 0 Then psChar -12 / XScale, Y2 - 10 * Len(A) / YScale, YText, 0, 2
    
End Sub


Public Sub psBox(ByVal XA!, ByVal XE!, ByVal YA!, ByVal YE!, _
  Optional Schraffur& = 0)

' --- Zeichnen eines Rechtecks, optional mit Schraffur (20000) ---
'     XA, XE, YA, YE : Eckkoordinaten
'     Schraffur : Abstand und Neigung (negativ : nach links), 0 = keine

Dim X!, Y!, XD!
On Error Resume Next

  If XA > XE Then
    X = XE
    XE = XA
    XA = X
  End If
  If YA > YE Then
    Y = YE
    YE = YA
    YA = Y
  End If
    
' --- Rechteck zeichnen -----------

  psMove XA, YA
  psLine XA, YE
  psLine XE, YE
  psLine XE, YA
  psLine XA, YA
  
  If Schraffur = 0 Then Exit Sub
  
' ---- Schraffur ----

  For XD = 0 To (XE - XA) + (YE - YA) Step Abs(Schraffur)
    If XD < (YE - YA) Then
      X = XA
      Y = YE - XD
    Else
      X = XA + XD + YA - YE
      Y = YA
    End If
    If Schraffur < 0 Then Y = YE + YA - Y
    psMove X, Y
    If XD > (XE - XA) Then
      X = XE
      Y = YE + XE - XA - XD
    Else
      X = XA + XD
      Y = YE
    End If
    If Schraffur < 0 Then Y = YE + YA - Y
    psLine X, Y
  Next XD
  
End Sub


Public Sub psChar(ByVal X!, ByVal Y!, ByVal Zeichen$, _
  Optional Richtung& = 0, Optional Grsse& = 2)

' --- Plotten A$ ab x, y in Richtung
'     R= 0 : waagerecht, 1 : senkrecht,
'     2 : waagerecht auf dem Kopf, 3 : senkrecht gespiegelt
'     und relative Grsse ( Default = 2)

On Error Resume Next

  psMove X, Y
  ZeichenFolge Zeichen, Richtung, Grsse
  
End Sub

Public Sub psCircle(ByVal X!, ByVal Y!, ByVal RX!, ByVal RY!, _
  Optional ByVal WA! = 0, Optional ByVal WE! = 360)

' --- Zeichnen von (Teil) Kreisen und Ellipsen ( 21000) ----
'     X, Y   : Mittelpunktskoordinaten
'     RX, RY : Radius X, Y
'     WA, WE : Anfangs-, Endwinkel

Dim XA!, YA!, WS!, w!
On Error Resume Next

  RX = Abs(RX)
  RY = Abs(RY)
  XA = X
  YA = Y
  X = XA + RX * Cos(Atn(1) * WA / 45)
  Y = YA + RY * Sin(Atn(1) * WA / 45)
  psMove X, Y
  
  WS = Sgn(WE - WA) * 800 / (RX * XScale + RY * YScale + 40)
  For w = WA To WE Step WS
    X = XA + RX * Cos(Atn(1) * w / 45)
    Y = YA + RY * Sin(Atn(1) * w / 45)
    psLine X, Y
  Next w
  
  X = XA + RX * Cos(Atn(1) * WE / 45)
  Y = YA + RY * Sin(Atn(1) * WE / 45)
  psLine X, Y
  
End Sub


Public Function psClosePlotter()
Attribute psClosePlotter.VB_Description = "Schliessen Plotter und Interface"

' --- Schlieen Plotter, Interface ---

Dim res&

  res = 0
  If PlotPlotter Then
    res = ft.CloseInterface
    Set ft = Nothing
  End If
  psClosePlotter = res
  
End Function

Public Property Let psHeight(Y&)
Attribute psHeight.VB_Description = "Blatthhe in Plotterschritten"

' --- Blatthhe in Plotterschritten --------

  YMax = Y
  
End Property

Public Property Get psHeight() As Long

' --- Blatthhe in Plotterschritten --------

  psHeight = YMax
  
End Property


Public Sub psHome()
Attribute psHome.VB_Description = "Initialisieren des Plotters, Fahren auf Position 0,0"
  
' --- Init Blatt, Fahren zur Home-Position (40000) ---
'     Skalierung SP : in Plotterschritten a 0,39 mm
'     Steigung 4,75 mm / 48 Schritte/U * 4er Zyklus

On Error Resume Next

' --- Init Werte ---
  
  StiftAuf
  XMax = 680
  YMax = 500
  XHome = 0#
  YHome = 0#
  XScale = 1#
  YScale = 1#
  
' --- Fahren auf Home bzw. Clear picBlatt ---
  If PlotScreen Then
    SP.Cls
    SP.Scale (0, YMax)-(XMax, 0)
    SP.CurrentX = 300
    SP.CurrentY = 250
  End If
  
  If PlotScreen Then SP.Print "Fhrt auf Home-Position"
  
  Xout = False
  Yout = False
  
  If PlotPlotter Then
    
' --- Beide Motoren gegen Endtaster
    Do While (ft.StatusInputs And cMaskeEndeXY) = 0
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRLL
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLLL
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
      EndTaster
    Loop
  ' --- Motor X gegen Endtaster
    Do While (ft.StatusInputs And cMaskeEndeX) = 0
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRLR
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLLR
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
      EndTaster
    Loop
  ' --- Motor X frei von Endtaster
    Do While (ft.StatusInputs And cMaskeEndeX) <> 0
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLLR
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRLR
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
      EndTaster
    Loop
  ' --- Motor Y gegen Endtaster
    Do While (ft.StatusInputs And cMaskeEndeY) = 0
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRL
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRL
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
      EndTaster
    Loop
  ' --- Motor y frei von Endtaster
    Do While (ft.StatusInputs And cMaskeEndeY) <> 0
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRL
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRL
      EndTaster
      ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
      EndTaster
    Loop
    XpYpDiagonale                ' --- Motoren 2 Schritt Abstand von Ende
    XpYpDiagonale
    XposI = 0
    YposI = 0
  End If
    SP.Cls
  
End Sub

Public Sub psLine(ByVal X!, ByVal Y!)
Attribute psLine.VB_Description = "Zeichnen einer Linie von akt. Position nach X,Y"

' --- Linie von aktueller Position nach x, y (44000) ---

On Error Resume Next

  StiftAb
  Strich Int(XHome + XScale * X - XposI + 0.5), Int(YHome + YScale * Y - YposI + 0.5)
  
End Sub


Public Sub psMove(ByVal X!, ByVal Y!)
Attribute psMove.VB_Description = "Fahren von akt. Position nach X,Y"

' --- Zur Position x,y fahren (45000) -------

On Error Resume Next

  StiftAuf
  Strich Int(XHome + XScale * X - XposI + 0.5), _
    Int(YHome + YScale * Y - YposI + 0.5)

End Sub

Public Function psOpenPlotter(PortName$, Optional ShowPanel) As Integer
Attribute psOpenPlotter.VB_Description = "ffnen Interface und initialisieren Plotter"

' --- ffnen Interface, Initialisieren Plotter ---
'     Ausgabe in ShowPanel(PicturBox) erfolgt, wenn vorhanden

Dim res&
  
  PlotPlotter = False
  PlotScreen = False
  If UCase(PortName) = "SCR" Then
    If IsMissing(ShowPanel) Then
      res = ftiFehler
    Else
      PlotScreen = True
      Set SP = ShowPanel
      res = 0
    End If
  Else
    Set ft = New clsFishFace
    res = ft.OpenInterface(PortName, ShowPanel)
    If res <> ftiFehler Then
      PlotPlotter = True
      If Left$(UCase(PortName), 3) = "LPT" And ftOutputDelay = 0 Then ftOutputDelay = 60000
      If Not IsMissing(ShowPanel) Then
        PlotScreen = True
        Set SP = ShowPanel
      End If
    End If
  End If
  
  psOpenPlotter = res
  If res = ftiFehler Then Exit Function
  psHome
  
End Function

Public Sub psOrigin()
Attribute psOrigin.VB_Description = "Fahren zu Position 0,0"

' --- Fahren zum Nullpunkt ---

  psMove 0, 0

End Sub


Public Property Get psOutputDelay() As Long
Attribute psOutputDelay.VB_Description = "Dauer der Warteschleife bei der Ausgabe auf den LPT-Port"

' --- Wert der Warteschleife bei Ausgabe ber paralleles Interface ---

  psOutputDelay = ftOutputDelay
  
End Property

Public Property Let psOutputDelay(d&)

' --- Wert der Warteschleife bei Ausgabe ber paralleles Interface ---

  ftOutputDelay = (d&)
  
End Property



Public Sub psRChar(ByVal X!, ByVal Y!, ByVal Zeichen$, _
  Optional Richtung& = 0, Optional Grsse& = 2)

' --- Plotten A$ um x, y von der alten Position versetzt, Richtung
'     Richtung= 0 : waagerecht, 1 : senkrecht,
'               2 : waagerecht auf dem Kopf, 3 : senkrecht gespiegelt
'     und relative Grsse ( Default = 2)

On Error Resume Next

  psRMove X, Y
  ZeichenFolge Zeichen, Richtung, Grsse
  
End Sub

Public Sub psRLine(ByVal X!, ByVal Y!)
Attribute psRLine.VB_Description = "Zeichnen einer Linie von der akt. Position um Increment X,Y"

' --- x, y Werte Zeichnen (46000) ----

On Error Resume Next

  StiftAb
  Strich Int(XScale * X + 0.5), Int(YScale * Y + 0.5)
  
End Sub

Public Sub psRMove(ByVal X!, ByVal Y!)
Attribute psRMove.VB_Description = "Fahren von akt. Position um Increment X,Y"

' ---- x, y Werte Fahren (47000) ----

On Error Resume Next

  StiftAuf
  Strich Int(XScale * X + 0.5), Int(YScale * Y + 0.5)

End Sub

Public Sub psScale(ByVal XMin!, ByVal XMax!, ByVal YMin!, ByVal YMax!)
Attribute psScale.VB_Description = "Setzen eines neuen Koordinaten Nullpunktes und Mastabes"

' --- Setzen Skalierung ----

On Error Resume Next

  If Not (XMin < XMax) Or Not (YMin < YMax) Then Exit Sub
  XScale = XMax / (XMax - XMin)
  XScale = YMax / (YMax - YMin)
  XHome = -XMin * XScale
  YHome = -YMin * YScale
  
End Sub


Public Sub psSetOrigin(ByVal X&, ByVal Y&)
Attribute psSetOrigin.VB_Description = "Setzen eines neuen Koordinatennullpunktes"

' --- Setzen Koordinaten Nullpunkt ---

On Error Resume Next

  XHome = XHome + X * XScale
  YHome = YHome + Y * YScale
  
End Sub

Private Sub BereichsLimit()

' --- Feststellen ob im Plotbereich (61000) ---

  If Xout Or Yout Then   ' --- Letzte Position auerhalb
    Xout = XposI < 0 Or XposI > XMax
    Yout = YposI < 0 Or YposI > YMax
    If Xout Or Yout Then
      Exit Sub
    Else
      If MG Then
        MG = True
        StiftAb
      End If
    End If
  Else                   ' --- Letzte Position innerhalb
    Xout = XposI < 0 Or XposI > XMax
    Yout = YposI < 0 Or YposI > YMax
    If Xout Or Yout Then
      MG = True
      StiftAuf
    End If
  End If
  
End Sub

Private Sub EndTaster()

' --- Abfrage Endtaster im laufenden Betrieb (60000) ---

' --- E7 oder E8 : Nachricht "Dejustierung"
Dim i&

  For i = 1 To ftOutputDelay           ' --- Warteschleife fr LPT
  Next i
  
  If ((ft.StatusInputs And cMaskeEndeX) <> 0 And XposI <> 0) Or _
    ((ft.StatusInputs And cMaskeEndeY) <> 0 And YposI <> 0) Then
    MsgBox "Achtung Dejustierung!", vbExclamation + vbOKOnly, "ftPlot"
  End If
  
End Sub


Public Property Get psWidth() As Long
Attribute psWidth.VB_Description = "Blattbreite in Plotterschritten"

' --- Blattbreite in Plotterschritten ---

  psWidth = XMax
  
End Property

Public Property Let psWidth(X&)

' --- Blattbreite in Plotterschritten ---

  XMax = X
  
End Property

Private Sub StiftAb()

' --- Senken Stift (58000) ----
  
  If MG Then Exit Sub
  If Xout Or Yout Then Exit Sub
  
  ' --- Code Senken
  If PlotPlotter Then
    ft.ClearMotors
    Sleep 10                     ' --- Verschnaufpause fr schwache Netzteile
    ft.SetMotor cStift, ftiEin
    Sleep 10                     ' --- Ein Stift ist ja kein D-Zug
  End If
  MG = True
  
End Sub

Private Sub StiftAuf()

' --- Heben Stift (59000) ---

  If Not MG Then Exit Sub
  ' --- Code Heben
  If PlotPlotter Then
    ft.SetMotor cStift, ftiEin
    ft.SetMotor cStift, ftiAus
    Sleep 10                       ' --- Gnnen wir ihm die Zeit
  End If
  MG = False
  
End Sub

Private Sub Strich(XR&, YR&)

' --- Allgemeiner Fahrauftrag ---

Dim DX&, DY&, d&, NX&, NY&

  DX = Abs(XR)                      ' --- Anzahl Plotterschritte
  DY = Abs(YR)
  NX = 0                            ' --- Schrittzhler
  NY = 0
  d = 0                             ' --- Abstand zur optimalen Geraden
  Do Until NX = DX And NY = DY
    If Abs(d + DY) < Abs(d + DY - DX) Then  ' --- X-Schritt
      If XR > 0 Then XPlusSchritt Else XMinusSchritt
      NX = NX + 1
      d = d + DY
    ElseIf Abs(d - DX) < Abs(d + DY - DX) Then ' --- Y-Schritt
      If YR > 0 Then YPlusschritt Else YMinusSchritt
      NY = NY + 1
      d = d - DX
    Else                            ' --- Diagonale
      If XR > 0 Then
        If YR > 0 Then XpYpDiagonale Else XpYmDiagonale
      Else
        If YR > 0 Then XmYpDiagonale Else XmYmDiagonale
      End If
      NX = NX + 1
      NY = NY + 1
      d = d + DY - DX
    End If
  Loop
  
End Sub

Private Sub XMinusSchritt()

' --- -X Bewegung (51000) ----

  XposI = XposI - 1
  BereichsLimit
  If Xout Then Exit Sub
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then SP.Line (XposI + 1, YposI)-(XposI, YposI), cStiftAb
  If Not PlotPlotter Then Exit Sub
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRLR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLLR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
  EndTaster
    
End Sub

Private Sub XPlusSchritt()

' --- +X Bewegung (50000) ----

  XposI = XposI + 1
  BereichsLimit
  If Xout Then Exit Sub
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then SP.Line (XposI - 1, YposI)-(XposI, YposI), cStiftAb
  If Not PlotPlotter Then Exit Sub
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLLR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRLR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
  EndTaster
  
End Sub

Private Sub XpYpDiagonale()

' --- +X/+Y-Diagonale (54000) --------

  XposI = XposI + 1
  YposI = YposI + 1
  BereichsLimit
  If Xout Then
    YPlusschritt
    Exit Sub
  ElseIf Yout Then
    XPlusSchritt
    Exit Sub
  End If
  
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then SP.Line (XposI - 1, YposI - 1)-(XposI, YposI), cStiftAb
  If Not PlotPlotter Then Exit Sub
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLLL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRLL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
  EndTaster

End Sub

Private Sub XpYmDiagonale()

' --- +X/-Y-Diagonale (55000) --------

  XposI = XposI + 1
  YposI = YposI - 1
  BereichsLimit
  If Xout Then
    YMinusSchritt
    Exit Sub
  ElseIf Yout Then
    XPlusSchritt
    Exit Sub
  End If
  
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then SP.Line (XposI - 1, YposI + 1)-(XposI, YposI), cStiftAb
  If Not PlotPlotter Then Exit Sub
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLLR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRLR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
  EndTaster

End Sub

Private Sub XmYmDiagonale()

' --- -X/-Y-Diagonale (57000) --------

  XposI = XposI - 1
  YposI = YposI - 1
  BereichsLimit
  If Xout Then
    YMinusSchritt
    Exit Sub
  ElseIf Yout Then
    XMinusSchritt
    Exit Sub
  End If
  
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then SP.Line (XposI + 1, YposI + 1)-(XposI, YposI), cStiftAb
  If Not PlotPlotter Then Exit Sub
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRLL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLLL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
  EndTaster

End Sub

Private Sub XmYpDiagonale()

' --- -X/+Y-Diagonale (56000) --------

  XposI = XposI - 1
  YposI = YposI + 1
  BereichsLimit
  If Xout Then
    YPlusschritt
    Exit Sub
  ElseIf Yout Then
    XMinusSchritt
    Exit Sub
  End If
  
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then SP.Line (XposI + 1, YposI - 1)-(XposI, YposI), cStiftAb
  If Not PlotPlotter Then Exit Sub
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRLR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLLR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
  EndTaster

End Sub
Private Sub YMinusSchritt()

' --- -Y Bewegung (53000) ----

  YposI = YposI - 1
  BereichsLimit
  If Yout Then Exit Sub
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then SP.Line (XposI, YposI + 1)-(XposI, YposI), cStiftAb
  If Not PlotPlotter Then Exit Sub
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
  EndTaster

End Sub

Private Sub YPlusschritt()

' --- +Y Bewegung (52000) ----

  YposI = YposI + 1
  BereichsLimit
  If Yout Then Exit Sub
  ' --- Code Zeichnen in picBlatt bzw. Plotten, Endtasterabfrage
  If MG Then SP.Line (XposI, YposI - 1)-(XposI, YposI), cStiftAb
  If Not PlotPlotter Then Exit Sub
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRR
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsLRL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRL
  EndTaster
  ft.SetMotors (ft.StatusOutputs And cMaskeStift) + cMotorsRRR
  EndTaster

End Sub


Private Sub ZeichenFolge(A$, R&, G&)

' --- Zeichnen A$ ab aktueller Position in ZRichtung, ZGrsse ---
'     in ZTab sind jeweils zwei Koordinatenpaare kodiert

Dim i&, j&, J1&, Xalt&, Yalt&, Xneu&, Yneu&, Pens As Boolean, Zeichen&

  If Len(A) = 0 Then Exit Sub
  For i = 1 To Len(A)                    ' --- Schleife ber Zeichen
    Xalt = 0                             '     Startpunkt
    Yalt = 3
    If Mid$(A, i, 1) = vbBack Then       ' --- Zeichen berschreiben
      ZeichenVektor Xalt, -5, Yalt, 3, False, R, G
    Else                                 ' --- Zeichen auf neue Position
      For j = 0 To 8                     ' --- Schleife ber ZeichenVektor
        Zeichen = ZTab(Asc(Mid$(A, i, 1)), j)
        If Zeichen = 0 Then Exit For
        For J1 = 0 To 1                  ' --- Code Teil 1 / 2
          If Zeichen > 0 Then
            Xneu = Int(Zeichen / 1000)
            Yneu = Int(Zeichen / 100) - 10 * Xneu
            Zeichen = 100 * (Zeichen - 1000 * Xneu - 100 * Yneu)
            Pens = False
            If Xneu > 4 Then
              Xneu = Xneu - 5
              Pens = True
            End If
            ZeichenVektor Xalt, Xneu, Yalt, Yneu, Pens, R, G
            Xalt = Xneu
            Yalt = Yneu
          End If
        Next J1
      Next j
      ZeichenVektor Xalt, 5, Yalt, 3, False, R, G
    End If
  Next i
  
End Sub

Private Sub ZeichenVektor(Xalt&, Xneu&, Yalt&, Yneu&, Pens As Boolean, R, G)

' --- Zeichnen Vektor relativ zur aktuellen Position ---

Dim X&, Y&, XY&

  X = (Xneu - Xalt) * G
  Y = (Yneu - Yalt) * G
  Select Case R
  Case 0
  Case 1
    XY = X
    X = -Y
    Y = XY
  Case 2
    X = -X
    Y = -Y
  Case 3
    XY = X
    X = Y
    Y = -XY
  End Select
  If Pens Then psRLine X / XScale, Y / YScale Else psRMove X / XScale, Y / YScale
  
End Sub


Private Sub Class_Initialize()

Dim Kanal%, i&, j&, w&

  ChDir App.Path
  ChDrive App.Path
  Kanal = FreeFile
  
  Open "ftPlot85.DAT" For Input As #Kanal       ' --- Lesen Zeichensatz
  For i = 0 To 255
    Input #Kanal, w
    For j = 0 To 9
      Input #Kanal, ZTab(i, j)
    Next j
  Next i
  Close #Kanal

End Sub


